// Generated by CoffeeScript 1.9.3
var Logger, levels, root;

root = require('./utils').root;

levels = ['debug', 'info', 'warn', 'error'];

Logger = (function() {
  function Logger(options) {
    var fn, i, len, level;
    fn = (function(_this) {
      return function(level) {
        return _this[level] = function() {
          var args;
          args = Array.prototype.slice.call(arguments);
          args.unshift('bebop:' + level);
          return _this.log.apply(_this, args);
        };
      };
    })(this);
    for (i = 0, len = levels.length; i < len; i++) {
      level = levels[i];
      fn(level);
    }
  }

  Logger.prototype.log = function() {
    return typeof console !== "undefined" && console !== null ? console.log.apply(console, arguments) : void 0;
  };

  Logger.prototype.setLevels = function(levels) {
    return this.levels = levels;
  };

  Logger.prototype.debug = function(enable) {
    if (enable) {
      return this.setLevels(levels);
    } else {
      return this.setLevels(['info', 'warning', 'error']);
    }
  };

  return Logger;

})();

module.exports = new Logger();
