// Generated by CoffeeScript 1.9.3
var findNode, load, log, parseFilename, reloadNode, tags, urlRandomize;

tags = require('./tags');

log = require('./log');

urlRandomize = require('./utils').urlRandomize;

parseFilename = function(filename) {
  var ext, path, resource;
  path = filename.split('/');
  filename = path.pop();
  ext = filename.split('.')[1];
  resource = {
    ext: ext,
    filename: filename,
    path: path,
    tag: tags[ext]
  };
  return resource;
};

findNode = function(filename) {
  var i, len, node, re, ref, resource;
  if (filename === '') {
    return;
  }
  if ((resource = parseFilename(filename)).tag == null) {
    return;
  }
  re = new RegExp(filename + '$');
  ref = document.getElementsByTagName(resource.tag.name);
  for (i = 0, len = ref.length; i < len; i++) {
    node = ref[i];
    if (re.test((node[resource.tag.link].split('?'))[0])) {
      resource.url = node[resource.tag.link];
      node._resource = resource;
      return node;
    }
  }
  return null;
};

reloadNode = function(node) {
  var link;
  if (node._resource.ext === 'js') {
    node.parentNode.removeChild(node);
    return load(node._resource);
  }
  link = node._resource.tag.link;
  if (navigator.userAgent.toLowerCase().indexOf('chrome') > -1) {
    node[link] = '#break-the-url';
  }
  node[link] = urlRandomize(node._resource.url);
  return log.info('resource-reloaded', node[link]);
};

load = function(resource) {
  var node;
  node = document.createElement(resource.tag.name);
  node[resource.tag.link] = resource.url;
  node.type = resource.tag.type;
  document.getElementsByTagName('head')[0].appendChild(node);
  return log.info('resource-loaded', node[resource.tag.link]);
};

module.exports = {
  findNode: findNode,
  reloadNode: reloadNode,
  load: load
};
