// Generated by CoffeeScript 1.9.3
var chrome, firefox, other, stringifyArguments;

stringifyArguments = function(args) {
  var arg, i, result, slice;
  result = [];
  slice = Array.prototype.slice;
  i = 0;
  while (i < args.length) {
    arg = args[i];
    if (arg === void 0) {
      result[i] = 'undefined';
    } else if (arg === null) {
      result[i] = 'null';
    } else if (arg.constructor) {
      if (arg.constructor === Array) {
        if (arg.length < 3) {
          result[i] = '[' + stringifyArguments(arg) + ']';
        } else {
          result[i] = '[' + stringifyArguments(slice.call(arg, 0, 1)) + '...' + stringifyArguments(slice.call(arg, -1)) + ']';
        }
      } else if (arg.constructor === Object) {
        result[i] = '#object';
      } else if (arg.constructor === Function) {
        result[i] = '#function';
      } else if (arg.constructor === String) {
        result[i] = '"' + arg + '"';
      } else {
        if (arg.constructor === Number) {
          result[i] = arg;
        }
      }
    }
    ++i;
  }
  return result.join(',');
};

chrome = function(e) {
  var stack;
  stack = (e.stack + '\n').replace(/^\S[^\(]+?[\n$]/g, '').replace(/^\s+(at eval )?at\s+/g, '').replace(/^([^\(]+?)([\n$])/g, '{anonymous}()@$1$2').replace(/^Object.<anonymous>\s*\(([^\)]+)\)/g, '{anonymous}()@$1').split('\n');
  stack.pop();
  return stack;
};

firefox = function(e) {
  return e.stack.replace(/(?:\n@:0)?\s+$/m, '').replace(/^\(/g, '{anonymous}(').split('\n');
};

other = function(curr) {
  var ANON, args, fn, fnRE, maxStackSize, stack;
  ANON = '{anonymous}';
  fnRE = /function\s*([\w\-$]+)?\s*\(/i;
  stack = [];
  fn = void 0;
  args = void 0;
  maxStackSize = 10;
  while (curr && curr['arguments'] && stack.length < maxStackSize) {
    fn = (fnRE.test(curr.toString()) ? RegExp.$1 || ANON : ANON);
    args = Array.prototype.slice.call(curr['arguments'] || []);
    stack[stack.length] = fn + '(' + stringifyArguments(args) + ')';
    curr = curr.caller;
  }
  return stack;
};

module.exports = function(e) {
  if (e['arguments'] && e.stack) {
    return method.chrome(e);
  }
  if (e.stack) {
    return method.firefox(e);
  }
  return method.other(e);
};
