// Generated by CoffeeScript 1.9.3
var _, colors, fn, log, method, pretty, theme;

colors = require('colors/safe');

theme = {
  debug: 'blue',
  info: 'white',
  warn: 'yellow',
  error: 'red',
  bebop: 'black',
  modified: 'cyan',
  compiled: 'blue'
};

colors.setTheme(theme);

pretty = function(obj) {
  return JSON.stringify(obj, null, 2);
};

log = function() {
  if (root.console == null) {
    return console.log.apply(console, arguments);
  }
};

fn = function(method) {
  var prefix;
  prefix = colors[method](method + ' ');
  return log[method] = function(msg, extra) {
    if (typeof msg === 'string') {
      msg = prefix + msg;
    } else {
      msg = prefix + '\n' + pretty(msg);
    }
    if (extra != null) {
      return console.log(msg, '\n' + pretty(extra));
    } else {
      return console.log(msg);
    }
  };
};
for (method in theme) {
  _ = theme[method];
  fn(method);
}

module.exports = log;
