// Generated by CoffeeScript 1.9.3
var fs, middleware, path;

fs = require('fs');

path = require('path');

middleware = function(opts) {
  var _middleware, bebopJs, injectJs, serveStatic;
  if (opts == null) {
    opts = {};
  }
  bebopJs = "<script src=\"/bebop.js\"></script>\n<script>\n  var bebop = new Bebop(" + (JSON.stringify(opts)) + ");\n  bebop.debug = true;\n  bebop.connect();\n</script>";
  injectJs = function(res) {
    var appendScript, end, setHeader;
    appendScript = false;
    end = res.end;
    setHeader = res.setHeader;
    res.setHeader = function(name, value) {
      if (/text\/html/i.test(value)) {
        appendScript = true;
      } else if (name === 'Content-Length' && appendScript) {
        value = parseInt(value, 10) + bebopJs.length;
      }
      return setHeader.call(res, name, value);
    };
    return res.end = function(chunk, encoding) {
      if (appendScript) {
        res.write(bebopJs, encoding);
      }
      return end.call(res, chunk, encoding);
    };
  };
  serveStatic = function(req, res) {
    var contentType, file, headers;
    switch (req.url) {
      case '/bebop.js':
        contentType = 'application/javascript';
        break;
      default:
        contentType = 'application/coffeescript';
    }
    headers = {
      'Content-Type': contentType
    };
    if (/^\/src\/node_modules/.test(req.url)) {
      req.url = req.url.substring(4);
    }
    file = path.join(__dirname, '/..', req.url);
    res.writeHead(200, headers);
    return fs.createReadStream(file).pipe(res);
  };
  _middleware = function(req, res, next) {
    if ((/^\/bebop/.test(req.url)) || (/^\/src/.test(req.url))) {
      return serveStatic(req, res);
    }
    injectJs(res);
    return next();
  };
  return function bebop(req, res, next) { return _middleware(req, res, next); };;
};

module.exports = function(opts) {
  var _middleware, inject, injectConnectApp, injectHttpServer;
  if (opts == null) {
    opts = {};
  }
  if (typeof opts === 'function') {
    opts = {
      attach: opts
    };
  }
  _middleware = middleware(opts);
  injectConnectApp = function(app) {
    app.stack.splice(2, 0, {
      route: '',
      handle: _middleware
    });
    return app;
  };
  injectHttpServer = function(server) {
    var app;
    app = server.listeners('request')[0];
    if (typeof app === 'function') {
      server.removeListener('request', app);
    }
    return server.on('request', function(req, res) {
      return _middleware(req, res, function() {
        return app(req, res);
      });
    });
  };
  inject = function(app) {
    if (require('connect')().toString() === app.toString()) {
      return injectConnectApp(app);
    } else {
      return injectHttpServer(app);
    }
  };
  if (opts.attach != null) {
    return inject(opts.attach);
  }
  return _middleware;
};
