// Generated by CoffeeScript 1.9.3
var basicAuth, connect, favicons, index, log, logger, markdown, middleware, parseUrl, path, serveStatic;

basicAuth = require('basic-auth-connect');

connect = require('connect');

favicons = require('connect-favicons');

index = require('serve-index');

logger = require('morgan');

parseUrl = require('parseurl');

path = require('path');

serveStatic = require('serve-static');

log = require('./log');

markdown = require('./markdown');

middleware = require('./middleware');

module.exports = {
  createServer: function(opts) {
    var app, server;
    if (opts == null) {
      opts = {};
    }
    if (opts.host == null) {
      opts.host = '0.0.0.0';
    }
    if (opts.port == null) {
      opts.port = 1987;
    }
    if (opts.staticDir == null) {
      opts.staticDir = process.cwd();
    }
    app = connect();
    app.use(function(req, res, next) {
      req.path = parseUrl(req).pathname;
      return next();
    });
    app.use(favicons(__dirname + '/../assets'));
    app.use(middleware());
    app.use(logger('dev'));
    if (opts.user && opts.pass) {
      app.use(basicAuth(opts.user, opts.pass));
    }
    app.use(markdown());
    app.use(serveStatic(opts.staticDir));
    app.use(index(opts.staticDir, {
      hidden: true
    }));
    server = require('http').createServer(app);
    server.setMaxListeners(100);
    server.on('listening', function() {
      var cwd, dir;
      cwd = process.cwd();
      dir = path.basename(cwd);
      return log.bebop("serving " + dir + " at http://" + opts.host + ":" + opts.port);
    });
    server.run = function(cb) {
      if (cb == null) {
        cb = function() {};
      }
      process.once('uncaughtException', function(err) {
        if (err.code === 'EADDRINUSE') {
          log.error('address in use, retrying...');
          server.close();
          opts.port++;
          return setTimeout(server.run, 1000);
        } else {
          throw err;
        }
      });
      return server.listen(opts.port, opts.host, cb);
    };
    return server;
  }
};
